commit 8cfd82525fd0f902afb5e7894c709df0ea437cf9
Author: freddy77 <freddy77>
Date:   Tue Jan 29 10:14:23 2008 +0000

    handle errors from convert_tds2sql

diff --git b/ChangeLog a/ChangeLog
index b0130db..6ea3faa 100644
--- b/ChangeLog
+++ a/ChangeLog
@@ -1,8 +1,3 @@
-Tue Jan 29 11:12:44 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
-	* src/odbc/convert_tds2sql.c src/odbc/odbc.c src/odbc/odbc_util.c:
-	* src/odbc/unittests/getdata.c:
-	- backported fix for error handling in SQLGetData/SQLFetch
-
 Sun Jan 27 11:40:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* configure.ac src/apps/Makefile.am:
 	- backported fix for bsqlodbc dependency
@@ -71,4 +66,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2454.2.14 2008/01/29 10:14:23 freddy77 Exp $
+$Id: ChangeLog,v 1.2454.2.13 2008/01/27 10:41:21 freddy77 Exp $
diff --git b/src/odbc/convert_tds2sql.c a/src/odbc/convert_tds2sql.c
index cc7bc7d..04e0b8a 100644
--- b/src/odbc/convert_tds2sql.c
+++ a/src/odbc/convert_tds2sql.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.49.2.1 2008/01/29 10:14:28 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.49 2007/05/25 09:10:10 freddy77 Exp $");
 
 TDS_INT
 convert_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srclen, int desttype, TDS_CHAR * dest, SQLULEN destlen,
@@ -56,7 +56,7 @@ convert_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srcl
 	TIMESTAMP_STRUCT *tssp;
 	SQL_NUMERIC_STRUCT *num;
 
-	int ret = TDS_CONVERT_FAIL;
+	int ret = TDS_FAIL;
 	int i, cplen;
 
 	tdsdump_log(TDS_DBG_FUNC, "convert_tds2sql: src is %d dest = %d\n", srctype, desttype);
@@ -89,7 +89,7 @@ convert_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srcl
 			} else {
 				/* if destlen == 0 we return only length */
 				if (destlen != 0)
-					ret = TDS_CONVERT_FAIL;
+					ret = TDS_FAIL;
 			}
 			return ret;
 		}
@@ -143,7 +143,7 @@ convert_tds2sql(TDSCONTEXT * context, int srctype, TDS_CHAR * src, TDS_UINT srcl
 		} else {
 			/* if destlen == 0 we return only length */
 			if (destlen != 0)
-				ret = TDS_CONVERT_FAIL;
+				ret = TDS_FAIL;
 		}
 		break;
 
diff --git b/src/odbc/odbc.c a/src/odbc/odbc.c
index a639c4c..1e3c3a8 100644
--- b/src/odbc/odbc.c
+++ a/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.464.2.5 2008/01/29 10:14:29 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.464.2.4 2008/01/27 10:41:23 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -3340,28 +3340,6 @@ odbc_process_tokens(TDS_STMT * stmt, unsigned flag)
 	}
 }
 
-static void
-odbc_convert_err_set(struct _sql_errors *errs, TDS_INT err)
-{
-	switch (err) {
-	case TDS_CONVERT_NOAVAIL:
-		odbc_errs_add(errs, "HY003", NULL);
-		break;
-	case TDS_CONVERT_SYNTAX:
-		odbc_errs_add(errs, "22018", NULL);
-		break;
-	case TDS_CONVERT_OVERFLOW:
-		odbc_errs_add(errs, "22003", NULL);
-		break;
-	case TDS_CONVERT_FAIL:
-		odbc_errs_add(errs, "07006", NULL);
-		break;
-	case TDS_CONVERT_NOMEM:
-		odbc_errs_add(errs, "HY001", NULL);
-		break;
-	}
-}
-
 /*
  * - handle correctly SQLGetData (for forward cursors accept only row_size == 1
  *   for other types application must use SQLSetPos)
@@ -3596,7 +3574,6 @@ _SQLFetch(TDS_STMT * stmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 				len = convert_tds2sql(context, tds_get_conversion_type(colinfo->column_type, colinfo->column_size),
 						      src, srclen, c_type, data_ptr, drec_ard->sql_desc_octet_length, drec_ard);
 				if (len < 0) {
-					odbc_convert_err_set(&stmt->errs, len);
 					row_status = SQL_ROW_ERROR;
 					break;
 				}
@@ -4614,19 +4591,10 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 		nSybType = tds_get_conversion_type(colinfo->column_type, colinfo->column_size);
 		if (fCType == SQL_C_DEFAULT)
 			fCType = odbc_sql_to_c_type_default(stmt->ird->records[icol - 1].sql_desc_concise_type);
-		if (fCType == SQL_ARD_TYPE) {
-			if (icol > stmt->ard->header.sql_desc_count) {
-				odbc_errs_add(&stmt->errs, "07009", NULL);
-				ODBC_RETURN(stmt, SQL_ERROR);
-			}
-			fCType = stmt->ard->records[icol - 1].sql_desc_concise_type;
-		}
 		assert(fCType);
 		*pcbValue = convert_tds2sql(context, nSybType, src, srclen, fCType, (TDS_CHAR *) rgbValue, cbValueMax, NULL);
-		if (*pcbValue < 0) {
-			odbc_convert_err_set(&stmt->errs, *pcbValue);
+		if (*pcbValue < 0)
 			ODBC_RETURN(stmt, SQL_ERROR);
-		}
 
 		if (is_variable_type(colinfo->column_type) && (fCType == SQL_C_CHAR || fCType == SQL_C_BINARY)) {
 			/* calc how many bytes was readed */
diff --git b/src/odbc/odbc_util.c a/src/odbc/odbc_util.c
index bd73130..fb38d5b 100644
--- b/src/odbc/odbc_util.c
+++ a/src/odbc/odbc_util.c
@@ -38,7 +38,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.94.2.1 2008/01/29 10:14:31 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.94 2007/06/19 13:31:34 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -140,7 +140,7 @@ odbc_set_return_status(struct _hstmt *stmt, unsigned int n_row)
 
 		len = convert_tds2sql(context, SYBINT4, (TDS_CHAR *) & tds->ret_status, sizeof(TDS_INT),
 				      drec->sql_desc_concise_type, (void *) data_ptr, drec->sql_desc_octet_length, NULL);
-		if (len < 0)
+		if (TDS_FAIL == len)
 			return /* SQL_ERROR */ ;
 		if (drec->sql_desc_indicator_ptr)
 			LEN(drec->sql_desc_indicator_ptr) = 0;
diff --git b/src/odbc/unittests/getdata.c a/src/odbc/unittests/getdata.c
index 0c2d112..eead6e0 100644
--- b/src/odbc/unittests/getdata.c
+++ a/src/odbc/unittests/getdata.c
@@ -1,54 +1,15 @@
 #include "common.h"
 
-static char software_version[] = "$Id: getdata.c,v 1.4.2.1 2008/01/29 10:14:31 freddy77 Exp $";
+static char software_version[] = "$Id: getdata.c,v 1.4 2007/08/07 09:20:32 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-static char odbc_err[256];
-static char odbc_sqlstate[6];
-
-static void
-ReadError(void)
-{
-	memset(odbc_err, 0, sizeof(odbc_err));
-	memset(odbc_sqlstate, 0, sizeof(odbc_sqlstate));
-	if (!SQL_SUCCEEDED(SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, (SQLCHAR *) odbc_sqlstate, NULL, (SQLCHAR *) odbc_err, sizeof(odbc_err), NULL))) {
-		printf("SQLGetDiagRec should not fail\n");
-		exit(1);
-	}
-	printf("Message: '%s' %s\n", odbc_sqlstate, odbc_err);
-}
-
-static void
-test_err(const char *data, int c_type, const char *state)
-{
-	char sql[128];
-	SQLRETURN rc;
-	SQLLEN ind;
-	const unsigned int buf_size = 128;
-	char *buf = (char *) malloc(buf_size);
-
-	sprintf(sql, "SELECT '%s'", data);
-	Command(Statement, sql);
-	SQLFetch(Statement);
-	rc = SQLGetData(Statement, 1, c_type, buf, buf_size, &ind);
-	free(buf);
-	if (rc != SQL_ERROR)
-		ODBC_REPORT_ERROR("SQLGetData error expected");
-	ReadError();
-	if (strcmp(odbc_sqlstate, state) != 0) {
-		fprintf(stderr, "Unexpected sql state returned\n");
-		Disconnect();
-		exit(1);
-	}
-	ResetStatement();
-}
-
 int
 main(int argc, char *argv[])
 {
 	char buf[16];
 	SQLINTEGER int_buf;
 	SQLLEN len;
+	int ms_db = 0;
 
 	Connect();
 
@@ -129,24 +90,14 @@ main(int argc, char *argv[])
 
 	ResetStatement();
 
+	ms_db = db_is_microsoft();
+
 	Disconnect();
 
-	use_odbc_version3 = 1;
-	Connect();
+	if (ms_db) {
+		use_odbc_version3 = 1;
+		Connect();
 
-	/* test error from SQLGetData */
-	/* wrong constant */
-	test_err("prova 123",           SQL_VARCHAR,     "HY003");
-	/* use ARD but no ARD data column */
-	test_err("prova 123",           SQL_ARD_TYPE,    "07009");
-	/* wrong conversion, int */
-	test_err("prova 123",           SQL_C_LONG,      "22018");
-	/* wrong conversion, int */
-	test_err("prova 123",           SQL_C_TIMESTAMP, "22018");
-	/* overflow */
-	test_err("1234567890123456789", SQL_C_LONG,      "22003");
-
-	if (db_is_microsoft()) {
 		Command(Statement, "SELECT CONVERT(TEXT,'')");
 
 		if (SQLFetch(Statement) != SQL_SUCCESS)
@@ -163,9 +114,9 @@ main(int argc, char *argv[])
 
 		if (SQLGetData(Statement, 1, SQL_C_CHAR, buf, 1, NULL) != SQL_NO_DATA)
 			ODBC_REPORT_ERROR("invalid return from SQLGetData");
-	}
 
-	Disconnect();
+		Disconnect();
+	}
 
 	printf("Done.\n");
 	return 0;

